#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <float.h>

#include "m.h"
#include "g.h"
#include "fit.h"

static char rcsid[] = {"$Id: fitcal.c,v 1.1.1.1 1997/07/10 17:59:57 kraemer Exp $"};

/*
   --- Functions to handle data calibration structures

       fitCalInit()    : initialize
       fitCalInspect() : inspect output
 
   Copyright  (C) 1987-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved
   $Log: fitcal.c,v $
   Revision 1.1.1.1  1997/07/10 17:59:57  kraemer
   revision for cvs

*/

int fitCalInit( struct SFITCAL *psFCal,
              unsigned long lFlag
            ) {
   int iRC = ERRFIT_BADADDR;
   char *pDbgMsg = __FILE__"(fitCalInit)", *pMsg = pDbgMsg;


if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s.....\n", pDbgMsg );
   if ( psFCal == NULL ) goto gError;

   psFCal -> dCoeff[0] = 0E0;
   psFCal -> dCoeff[1] = 1E0;
   psFCal -> nCoeff = 2;

   iRC = 0;
gError:;
   if ( (iRC < 0) && !(lFlag&FIT_NOMSG) ) {
      fitemsg( pMsg, iRC );
   }
if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s done\n", pDbgMsg );
   return(iRC);
}
/*
   =========================================================================
*/
int fitCalInspect( struct SFITCAL *psFCal,
                unsigned long lFlag
              ) {
   int iRC = ERRFIT_BADADDR;
   char *pDbgMsg = __FILE__"(fitCalInspect)", *pMsg = pDbgMsg;
   int ii;


if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s.....\n", pDbgMsg );
   if ( psFCal == NULL ) goto gError;

   fprintf( stderr, "<D> SFITCAL=%X\n", psFCal );
   fprintf( stderr, "<D> ncoeff=%d\n", psFCal->nCoeff );
   for ( ii=0; ii<psFCal->nCoeff; ii++ ) {
      fprintf( stderr, "<D> dcoeff[%d]=%G\n", ii, psFCal->dCoeff[ii] );
   }
   iRC = 0;
gError:;
   if ( (iRC < 0) && !(lFlag&FIT_NOMSG) ) {
      fitemsg( pMsg, iRC );
   }
if ( lFlag & FIT_DEBUG ) fprintf( stderr, "<D> %s done\n", pDbgMsg );
   return(iRC);
}
