#ifndef FIT_FITUSR_H
#define FIT_FITUSR_H
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#if defined(SUNOS4)
#include <floatingpoint.h>
#else
#include <float.h>
#endif
/*
   $Log: fitusr.h,v $
   Revision 1.3  2002/11/18 15:23:31  kraemer
   ifdef added

   Revision 1.2  1997/12/15 19:02:45  kraemer
   *** empty log message ***

   Revision 1.1.1.1  1997/07/10 18:00:07  kraemer
   revision for cvs

*/ 
                  /* structure with some info passed to user routine */
struct SFITUSR {
   void *uBase;
   void *mBase;
   void *mcBase;
   void *dBase;
   void *dSpare[6];
   void *LastBase;
};
                  /* flags to communicate with fit fct. */ 
#define FITFCT_NPAR    0   /* fct. should give # of parameters */
#define FITFCT_VAL     1   /* fct. should give start values */
#define FITFCT_DERIV   2   /* fct. should give fct. values & deriv.s */
#define FITFCT_FCT     3   /* fct. should give fct. values only */
#define FITFCT_DISP    4   /* fct. called when curve is displayed, give fct. values */
#define FITFCT_RESULT  5   /* fct. called when results are displayed */
#define FITFCT_CLEANUP 6   /* fct. should cleanup */ 
                           /* return codes the user function should provide*/
#define FITUSR_OK          0
#define FITUSR_NODERIV     1
#define FITUSR_SYS        -1
#define FITUSR_UNPHYSICAL -2  /* unphysical region entered  */
#define FITUSR_OFLOFCT    -3  /* function not calculable    */
#define FITUSR_FCTFAILED  -3  /* function not calculable    */
#define FITUSR_OFLODERIV  -4  /* derivatives not calculable */
#define FITUSR_DERIVFAILED -4 /* derivatives not calculable */
#define FITUSR_IDFAILED   -5  /* identifier resolution failed */

#if defined(AMIGA) && !defined(FIT_FIT_H)

int usrfct( void *, double *, double *, double *, double *,
            int, int, int );

void *mBase;
void *uBase;
void *mcBase;
void *dBase;

main( int argc, char **argv) {
   int *iRC;
   double *dPar, *ddPar, *dX, *dY;
   int *nPar, *nX, *iSwitch;
   void *pFitFct;

   struct SFITUSR *pUsr;

//fprintf( stderr, "<D> main...\n");
   sscanf( argv[1], "%X", &pFitFct );
   sscanf( argv[2], "%X", &dPar );
   sscanf( argv[3], "%X", &ddPar );
   sscanf( argv[4], "%X", &dX );
   sscanf( argv[5], "%X", &dY );
   sscanf( argv[6], "%X", &nPar );
   sscanf( argv[7], "%X", &nX );
   sscanf( argv[8], "%X", &iSwitch );
   sscanf( argv[9], "%X", &iRC );
   sscanf( argv[10], "%X", &pUsr );

//fprintf(stderr,"%d\n", argc );
//fprintf(stderr,"%s|\n", argv[0] );

//fprintf(stderr,"%X|\n", argv[1] );
//fprintf(stderr,"%X|\n", argv[2] );
//fprintf(stderr,"%X|\n", argv[3] );
//fprintf(stderr,"%X|\n", argv[4] );
//fprintf(stderr,"%X|\n", argv[5] );
//fprintf(stderr,"%X|\n", argv[6] );
//fprintf(stderr,"%X|\n", argv[7] );
//fprintf(stderr,"%X|\n", argv[8] );
//fprintf(stderr,"%X|\n", argv[9] );

   uBase = pUsr->uBase;
   mBase = pUsr->mBase;
   mcBase = pUsr->mcBase;
   dBase = pUsr->dBase;

//fprintf( stderr, "<D> main(usrfct)\n");
   *iRC = usrfct( pFitFct, dPar, ddPar, dX, dY, *nPar, *nX, *iSwitch );

//fprintf( stderr, "<D> main OK\n");
   return(*iRC);
}

#include <exec/memory.h>
#include <proto/exec.h>

#endif
#endif

