#ifndef G_GPICS_H
#define G_GPICS_H
/*

   Definitions for gpi-client-server

   Copyright  (C) 1992-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved

   $Log: gpics.h,v $
   Revision 1.1  1997/08/29 12:22:35  kraemer
   *** empty log message ***


*/

#if defined(GFXGPI)

                                      /* CS command header */
struct SGPICS {
   unsigned long lCmd;                /* command code */
   unsigned long lLen;                /* length of following data (bytes)*/
};
                                      /*  */
struct SGPICSWININITIALIZE {
   HAB hab;                           /* return value */
   int errno;                         /* system error, if any */
   unsigned long lOptions;
};
                                      /*  */
struct SGPICSWINTERMINATE {
   BOOL bSuccess;                     /* return value */
   int errno;                         /* system error, if any */
   HAB hab;                           /*  */
};
                                      /*  */
struct SGPICSWINDESTROYMSGQUEUE {
   BOOL bSuccess;                     /* return value */
   int errno;                         /* system error, if any */
   HAB hmq;                           /* */
};
                                      /*  */
struct SGPICSWINDESTROYWINDOW {
   BOOL bSuccess;                     /* return value */
   int errno;                         /* system error, if any */
   HAB hwnd;                          /* */
};
                                      /*  */
struct SGPICSWINCREATEMSGQUEUE {
   HMQ hmq;                           /* return value */
   int errno;                         /* system error, if any */
   HAB hab;                           /*  */
   unsigned long lQueueSize;
};
                                      /*  */
struct SGPICSWINOPENWINDOWDC {
   HDC hdc;                           /* return value */
   int errno;                         /* system error, if any */
   HWND hwnd;                         /*  */
};
                                      /*  */
struct SGPICSWINCREATESTDWINDOW {
   HWND hwnd;                         /* return value */
   int errno;                         /* system error, if any */
   HWND hwndParent;
   ULONG ulStyle;
   ULONG ulCreateFlags;
   char cClassClient[80];
   char cTitle[80];
   ULONG ulStyleClient;
   HMODULE hmoduleResource;
   ULONG ulID;
   HWND hwndClient;
};
                                      /*  */
struct SGPICSWINREGISTERCLASS {
   BOOL bRegistered;                  /* return value */
   int errno;                         /* system error, if any */
   HAB hab;                           /*  */
   char cClassName[80];
   void *pvWdwProc;                   /* N/A for RPC */
   ULONG ulClassStyle;
   USHORT usExtra;
};
                                      /*  */
struct SGPICSGPISETLINETYPE {
   BOOL bSuccess;
   int errno;                         /* system error, if any */
   HPS hps;
   long lLineType;
};
                                      /*  */
struct SGPICSGPISETLINEWIDTH {
   BOOL bSuccess;
   int errno;                         /* system error, if any */
   HPS hps;
   FIXED fxLineWidth;
};
                                      /*  */
struct SGPICSGPIPOLYLINE {
   long lHits;
   int errno;                         /* system error, if any */
   HPS hps;
   long lCount;
};
                                      /*  */
struct SGPICSWINSETWINDOWPOS {
   BOOL bSuccess;
   int errno;                         /* system error, if any */
   HWND hwnd, hwndBehind;
   long lx, ly, lcx, lcy;
   ULONG ulOptions;
};
                                      /*  */
struct SGPICSGPICREATEPS {
   HPS hps;
   int errno;                         /* system error, if any */
   HAB hab;
   HDC hdc;
   SIZEL sizel;
   ULONG ulOptions;
};

                                      /* commands */
enum { GPICS_RC=1,                    /* send return code */
       GPICS_WININITIALIZE,
       GPICS_WINTERMINATE,
       GPICS_WINCREATEMSGQUEUE,
       GPICS_WINDESTROYMSGQUEUE,
       GPICS_WINREGISTERCLASS,
       GPICS_WINCREATESTDWINDOW,
       GPICS_WINDESTROYWINDOW,
       GPICS_WINSETWINDOWPOS,
       GPICS_WINOPENWINDOWDC,
       GPICS_GPICREATEPS,
       GPICS_GPISETLINEWIDTH,
       GPICS_GPISETLINETYPE,
       GPICS_GPIPOLYLINE,
       GPICS_SHUTDOWN,
     };

#endif

#endif




