#ifndef IOUMAC_H
#define IOUMAC_H
/*
   Definitions for I/O of UMAC data 
   =================================

   Copyright  (C) 2001-2002 M.Kraemer, GSI Darmstadt 
                             all rights reserved   

   $Log: ioumac.h,v $
   Revision 1.1  2001/01/16 13:40:56  kraemer
   UMAC listmode format added


*/


#include "u.h"
#include "iofh.h"

#define IO_SYSSWAP   0x00000080       /* data swap needed */

                                      /* buffer element header */
struct SIOUMACBEH {
   long lDLen;                        /* length of buffer in 16bit words,
                                         without this header */ 
#if defined(U_BIG_ENDIAN)
   short iSubType, iType;             /* buffer subtype/type */ 
#elif defined(U_LITTLE_ENDIAN)
   short iType, iSubType;             /* buffer subtype/type */
#else
#error you loose, unknown endian
#endif
};

                                      /* datablock header */
struct SIOUMACDBH {
   unsigned short uiv[4];
};				      				      				      
                                      /* UMAC data types */
enum {
   IOUMAC_FILEHEAD=0,                 /* file header, subtype=0 */
   IOUMAC_DT3=3,                      /* buffer events, Random scan mode, 
                                         subtype=0 */
   IOUMAC_EOR=99,                     /* end-of-run message, subtype=0 */
};				      
                                      /* buffer header */
struct SIOUMACBH {
   struct SIOUMACDBH sDBH;            /* datablock header */     
};				      				      				      

                                      /* file header */
struct SIOUMACFH {
   struct SIOUMACBH sBH;              /* buffer header */
   unsigned char ucFile[80];
   unsigned char cPad[1024-80-sizeof(struct SIOUMACBH)];
};				      				      				      
                                      /* file data */
struct SIOUMACFD {
   struct SIOUMACBH sBH;              /* buffer header */
   unsigned short uiDLength;
   unsigned short uiDType;
   unsigned short uivData[512-2-sizeof(struct SIOUMACBH)/2];
};				      				      				      
                                      /* function prototypes */
int _ioumacbh( struct SIOUMACBH *, unsigned long );
int _ioumacfh( struct SIOUMACFH *, struct SIOFH *, unsigned long );				      
int _ioumacfd( struct SIOUMACBH *, unsigned long );

#endif
